//https://github.com/adafruit/Adafruit_NeoPixel/blob/master/examples/strandtest/strandtest.ino
//and
//https://create.arduino.cc/projecthub/robocircuits/neopixel-tutorial-1ccfb9
// NeoPixel Ring simple sketch (c) 2013 Shae Erisson
// Released under the GPLv3 license to match the rest of the
// Adafruit NeoPixel library
// Rainbow from https://codebender.cc/sketch:80438#Neopixel%20Rainbow.ino
// and button: //https://arduinogetstarted.com/tutorials/arduino-button

// NeoPixel Ring simple sketch (c) 2013 Shae Erisson
// Released under the GPLv3 license to match the rest of the
// Adafruit NeoPixel library
// modified: sgn, March 2022
// modified CES, June 2022

#include <Adafruit_NeoPixel.h>


// Which pin on the Arduino is connected to the NeoPixels?
#define PIN        12 // Cori Board 

// How many NeoPixels are attached to the Arduino?
#define NUMPIXELS   7 // 7 on final board

#define DELAYVAL  300 // Time (in milliseconds) to pause between pixels

volatile int i;

const int BUTTON_PIN1 = 1;
const int BUTTON_PIN2 = 2;
const int BUTTON_PIN3 = 3;
const int BUTTON_PIN4 = 4;
const int BUTTON_PIN5 = 5;
const int BUTTON_PIN6 = 6;
const int BUTTON_PIN7 = 7;


int buttonPins[] = {1, 2, 3, 4, 5, 6, 7};

int currentState1 = LOW;    // the current reading from the input pin
int currentState2 = LOW;
int currentState3 = LOW;
int currentState4 = LOW;
int currentState5 = LOW;
int currentState6 = LOW;
int currentState7 = LOW;

int buttonStates[7] = {0, 0, 0, 0, 0, 0, 0};

// When setting up the NeoPixel library, we tell it how many pixels,
// and which pin to use to send signals. Note that for older NeoPixel
// strips you might need to change the third parameter -- see the
// strandtest example for more information on possible values.
Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);


void setup() {
  pixels.begin(); // INITIALIZE NeoPixel strip object (REQUIRED)
  pixels.setBrightness(85); // about 1/3 brightness
  pixels.clear();
  delay(10);

  pinMode(BUTTON_PIN1, INPUT_PULLUP);
  pinMode(BUTTON_PIN2, INPUT_PULLUP);
  pinMode(BUTTON_PIN3, INPUT_PULLUP);
  pinMode(BUTTON_PIN4, INPUT_PULLUP);
  pinMode(BUTTON_PIN5, INPUT_PULLUP);
  pinMode(BUTTON_PIN6, INPUT_PULLUP);
  pinMode(BUTTON_PIN7, INPUT_PULLUP);

}

void loop() {

  for (int i = 0; i < 7; i++ ) {
    int state = digitalRead(buttonPins[i]);
    delay(100);
    if (state == HIGH ) {
      int current_number = buttonStates[i];
      buttonStates[i] = current_number + 1;
      if (buttonStates[i] == 7 ) {
        buttonStates[i] = 0;
      }
    }
  }

  for (int i = 0; i < 7; i++ ) {
    if (buttonStates[i] == 0) {
      pixs(i);
    }
    if (buttonStates[i] == 1) {
      happy(i);
    }
    if (buttonStates[i] == 2) {
      sad(i);
    }
    if (buttonStates[i] == 3) {
      silly(i);
    }
    if (buttonStates[i] == 4) {
      stupid(i);
    }
    if (buttonStates[i] == 5) {
      pregnant(i);
    }
    if (buttonStates[i] == 6) {
      nerd(i);
    }
  }
  delay(20);
}


// THE BELOW CONTROL PIXELS
void pixs(int i) {
  pixels.setPixelColor(i, pixels.Color(0, 0, 0));  //off
  pixels.show();
}

void happy(int i) {
  pixels.setPixelColor(i, pixels.Color(0, 255, 0));  //off
  pixels.show();
}

void sad(int i) {
  pixels.setPixelColor(i, pixels.Color(0, 255, 0));  //off
  pixels.show();
}

void silly(int i) {
  pixels.setPixelColor(i, pixels.Color(155, 155, 0));  //off
  pixels.show();
}


void stupid(int i) {
  pixels.setPixelColor(i, pixels.Color(155, 155, 0));  //off
  pixels.show();
}

void pregnant(int i) {
  pixels.setPixelColor(i, pixels.Color(155, 0, 135));  //off
  pixels.show();
}

void nerd(int i) {
  pixels.setPixelColor(i, pixels.Color(155, 0, 135));  //off
  pixels.show();
}
